/*******************************************************************/
/*                                                                 */
/*  Implantation des fonctions de la classe processus              */
/*                                                                 */
/*******************************************************************/
/*******************************************************************/

#include "pcslib.h"

/*******************************************************************/
/*                                                                 */
/*                  Constructeur                                   */
/*                                                                 */
/*  Cette routine cree un objet processus bidon.  Elle doit etre   */
/*  utilisee conjointement avec la fonction fork.                  */  
/*                                                                 */
/*                                                                 */
/*******************************************************************/
Pcs::Pcs() {}

/*******************************************************************/
/*                                                                 */
/*                  Constructeur                                   */
/*                                                                 */
/*  Cette routine permet de creer un processus.  Le processus      */
/*  executera le code contenu dans le fichier specifie en          */
/*  parametre.  La fonction retournera l'identificateur            */
/*  du nouveau processus.                                          */
/*                                                                 */
/*  PARAMETRES                                                     */
/*                                                                 */
/*    fichier : ce fichier contient le code executable du nouveau  */
/*              processus.                                         */
/*    par i   : Peut recevoir trois paramètres a passer au pcs     */
/*              peut modifier la fct pour plus de par. si besoin   */
/*                                                                 */
/*                                                                 */
/*******************************************************************/
Pcs::Pcs(char *fichier, char* arg1, char* arg2, char* arg3)
{
   if ((pcsid = fork()) == -1)
      perror("Classe Pcs Function Fork (Fork)");      
   else 
     if (pcsid == 0)
       if (execl(fichier, fichier, arg1, arg2, arg3, (char *)0)== -1)
          perror("Classe Pcs Function Fork (exec)");
}
/*******************************************************************/
/*                                                                 */
/*                  c r e e r _ p c s                              */
/*                                                                 */
/*  Cette routine permet de creer un processus.  Le processus      */
/*  executera le code contenu dans le fichier specifie en          */
/*  parametre.  La fonction retournera l'identificateur (pcsid)    */
/*  du nouveau processus.                                          */
/*                                                                 */
/*  PARAMETRES                                                     */
/*                                                                 */
/*    fichier : ce fichier contient le code executable du nouveau  */
/*              processus.                                         */
/*    par i   : Peut recevoir trois paramètres a passer au pcs     */
/*              peut modifier la fct pour plus de par. si besoin   */
/*                                                                 */
/*******************************************************************/
void Pcs::creer_pcs(char *fichier, char* arg1, char* arg2, char* arg3)
{
   if ((pcsid = fork()) == -1)
      perror("Classe Pcs Function Fork (Fork)");      
   else 
     if (pcsid == 0)
       if (execl(fichier,fichier,  arg1, arg2, arg3, (char *)0)== -1)
          perror("Classe Pcs Function Fork (exec)");
}
/*******************************************************************/
/*                                                                 */
/*              d e t r u i t _ p c s                              */
/*                                                                 */
/*  Cette routine detruit le processus                             */
/*                                                                 */
/*******************************************************************/
void Pcs::detruit_pcs()
{
  if (kill(pcsid, SIGKILL) == -1)
     perror("Classe Pcs Function Kill");
}
/*******************************************************************/
/*                                                                 */
/*                   a t t e n d r e _ p c s                       */
/*                                                                 */
/*  Cette routine permet au processus appelant d'attendre la fin   */
/*  de l'execution d'un processus qu'il a cree avant de poursuivre */
/*  la sienne.                                                     */
/*                                                                 */
/*******************************************************************/
int Pcs::attendre_pcs()
{
   if ((pcsid = waitpid(pcsid,&status,WUNTRACED)) == -1)
      perror("Classe Pcs Function Join");
   return(status);
               
}
